#ifndef _IPROXY_DYN_LANG_H_
#define _IPROXY_DYN_LANG_H_

#define NSIZE(a) (sizeof(a) / sizeof(a[0]))

typedef struct _IProxyDynLang IProxyDynLang;
typedef struct _DynLangParams DynLangParams;
typedef struct _DynLangParam  DynLangParam;
typedef struct _Array_Type    ARRAY_TYPE;
typedef struct _HashList_Type HASHLIST_TYPE;
typedef struct _Hash_Type     HASH_TYPE;
typedef enum   _TYPE_INFO     TYPE_INFO;

enum _TYPE_INFO {
    TYPE_I,                        // int型
    TYPE_L,                        // long型
    TYPE_F,                        // float型
    TYPE_D,                        // double型
    TYPE_S,                        // 文字列
    TYPE_AI,                       // int型の配列
    TYPE_AL,                       // long型の配列
    TYPE_AF,                       // Ffoat型の配列
    TYPE_AD,                       // double型の配列
    TYPE_H                         // ハッシュ型
};

struct _Array_Type {
    int len;
    void* value;
};
struct _HashList_Type {
    int len;
    HASHLIST_TYPE* hash;
};
struct _Hash_Type {
    char* key;
    TYPE_INFO value_type;
    void* value;
};

struct _DynLangParam {
    TYPE_INFO param_type;
    void* param_value;
};
struct _DynLangParams {
    int    argc;                       // DynLangParamの個数
    DynLangParam* argv;               // 引数情報
};

struct _IProxyDynLang
{
    void (*FP_proxy_init)(IProxyDynLang*, char* dynFileName);
    void (*FP_proxy_funcall)(IProxyDynLang*, char* funcName, DynLangParams* dynLangParams);
    void (*FP_proxy_funcall2)(IProxyDynLang*, char* className, char* funcName, DynLangParams* dynLangParams);
    void (*FP_proxy_end)(IProxyDynLang*);
#ifdef __cplusplus
    void init(char* dynFileName) {
        this->FP_proxy_init(this, dynFileName);
    };
    void funcall(char* funcName, DynLangParams* dynLangParams) {
        this->FP_proxy_funcall(this, funcName, dynLangParams);
    };
    void funcall2(char* className, char* funcName, DynLangParams* dynLangParams) {
        this->FP_proxy_funcall2(this, className, funcName, dynLangParams);
    };
    void end() {
        this->FP_proxy_end(this);
    }
#endif
};
#ifdef __cplusplus
extern "C" {
#endif
IProxyDynLang* GetProxyDynLang();
void IProxyDynLang_init(IProxyDynLang*, char* dynFileName);
void IProxyDynLang_funcall(IProxyDynLang*, char* funcName, DynLangParams* dynLangParams);
void IProxyDynLang_funcall2(IProxyDynLang*, char* className, char* funcName, DynLangParams* dynLangParams);
void IProxyDynLang_end(IProxyDynLang*);
#ifdef __cplusplus
}
#endif
#endif
